/* $Id: pval.h,v 1.1.1.1 2014/05/01 19:46:37 rkiesling Exp $ */

/*
  This file is part of Ctalk.
  Copyright  2005-2011 Robert Kiesling, rk3314042@gmail.com.
  Permission is granted to copy this software provided that this copyright
  notice is included in all source code modules.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software Foundation, 
  Inc., 51 Franklin St., Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef _PVAL_H
#define _PVAL_H

typedef struct _val VAL;

struct _val{
  int __type;
  union {
    void *__ptr;
    int __i;
    Boolean __b;
    double __d;          /* Double and float. */
#ifndef __APPLE__
    long double __ld;
#endif
    long __l;
    long long __ll;
  } __value;
  void *__deref_ptr;
};

#endif /* #ifndef _PVAL_H */
