/* $Id: argblk9.c,v 1.2 2014/05/04 08:34:29 rkiesling Exp $ */

/*
 *  Argument block called from a function, 
 *  and super used as a receiver in a simple expression. 
 *  
 *  Prints the original list elements, and then four "... l3" strings.
 */

int main () {

  String new sPrefix;
  List new l;
  String new s;
  Integer new n;

  sPrefix = "This element is ";

  l push "l1";
  l push "l2";

  l map {
    s = sPrefix + self;
    printf ("%s\n", s);

    /* This is the line we're testing. */
    super push "l3";

    /* break after printing four "... l3" strings. */
    n = n + 1;
    if (n >= 6)
      break;
  }

  exit(0);
}
